import "choerodon-ui/pro/lib/data-set/style";
import _DataSet from "choerodon-ui/pro/lib/data-set";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import React, { createContext, useMemo, useContext, useEffect } from 'react';
import { inject } from 'mobx-react';
import { observer } from 'mobx-react-lite';
import { injectIntl } from 'react-intl';
import { useResourceStore } from "../../../../stores";
import BaseInfoDataSet from "./BaseInfoDataSet";
import CasesDataSet from "./CasesDataSet";
import PodsDataset from "./PodsDataSet";
import DetailsStore from "./DetailsStore";
import useStore from "./useStore";
import openWarnModal from "../../../../../../utils/openWarnModal";
import getTablePostData from "../../../../../../utils/getTablePostData";
var Store = /*#__PURE__*/createContext();
export default Store;
export function useInstanceStore() {
  return useContext(Store);
}
export var StoreProvider = injectIntl(inject('AppState')(observer(function (props) {
  var projectId = props.AppState.currentMenuType.id,
      children = props.children,
      intl = props.intl;

  var _useResourceStore = useResourceStore(),
      _useResourceStore$res = _useResourceStore.resourceStore,
      _useResourceStore$res2 = _useResourceStore$res.getSelectedMenu,
      id = _useResourceStore$res2.id,
      parentId = _useResourceStore$res2.parentId,
      getViewType = _useResourceStore$res.getViewType,
      getUpTarget = _useResourceStore$res.getUpTarget,
      resourceStore = _useResourceStore.resourceStore,
      intlPrefix = _useResourceStore.intlPrefix,
      treeDs = _useResourceStore.treeDs;

  var istStore = useStore({
    defaultKey: getViewType === 'instance' ? 'cases' : 'details'
  });
  var tabs = useMemo(function () {
    return {
      CASES_TAB: 'cases',
      DETAILS_TAB: 'details',
      PODS_TAB: 'pods'
    };
  }, []);
  var detailsStore = useMemo(function () {
    return new DetailsStore();
  }, []);
  var baseDs = useMemo(function () {
    return new _DataSet(BaseInfoDataSet());
  }, []);
  var casesDs = useMemo(function () {
    return new _DataSet(CasesDataSet());
  }, []);
  var podsDs = useMemo(function () {
    return new _DataSet(PodsDataset({
      intl: intl,
      intlPrefix: intlPrefix
    }));
  }, []);

  function freshTree() {
    treeDs.query();
  }

  function queryData() {
    casesDs.reset();
    var tabKey = istStore.getTabKey;

    switch (tabKey) {
      case tabs.CASES_TAB:
        casesDs.query();
        break;

      case tabs.DETAILS_TAB:
        detailsStore.loadResource(projectId, id);
        break;

      case tabs.PODS_TAB:
        podsDs.query();
        break;

      default:
    }
  }

  function checkIstExist() {
    var _parentId$split = parentId.split('**'),
        _parentId$split2 = _slicedToArray(_parentId$split, 1),
        envId = _parentId$split2[0];

    return resourceStore.checkExist({
      projectId: projectId,
      type: 'instance',
      envId: envId,
      id: id
    }).then(function (isExist) {
      if (!isExist) {
        openWarnModal(freshTree, intl.formatMessage);
      }

      return isExist;
    });
  }

  useEffect(function () {
    checkIstExist().then(function (query) {
      if (query) {
        baseDs.transport.read.url = "/devops/v1/projects/".concat(projectId, "/app_service_instances/").concat(id);
        baseDs.query();
        casesDs.transport.read.url = "/devops/v1/projects/".concat(projectId, "/app_service_instances/").concat(id, "/events");

        podsDs.transport.read = function (_ref) {
          var data = _ref.data;

          var _parentId$split3 = parentId.split('**'),
              _parentId$split4 = _slicedToArray(_parentId$split3, 2),
              envId = _parentId$split4[0],
              appId = _parentId$split4[1];

          var postData = getTablePostData(data);
          var param = getViewType === 'instance' ? "&app_service_id=".concat(appId) : '';
          return {
            url: "devops/v1/projects/".concat(projectId, "/pods/page_by_options?env_id=").concat(envId, "&instance_id=").concat(id).concat(param),
            method: 'post',
            data: postData
          };
        };

        podsDs.transport.destroy = function (_ref2) {
          var data = _ref2.data;

          var _parentId$split5 = parentId.split('**'),
              _parentId$split6 = _slicedToArray(_parentId$split5, 2),
              envId = _parentId$split6[0],
              appId = _parentId$split6[1];

          var podId = data[0].id;
          return {
            url: "devops/v1/projects/".concat(projectId, "/pods/").concat(podId, "?env_id=").concat(envId),
            method: 'delete'
          };
        };

        queryData();
      }
    });
  }, [projectId, id, istStore.getTabKey, parentId]);
  useEffect(function () {
    var type = getUpTarget.type,
        istId = getUpTarget.id;

    if (type === 'instances' && istId === id) {
      queryData();
      resourceStore.setUpTarget({});
    }
  }, [getUpTarget]);

  var value = _objectSpread(_objectSpread({}, props), {}, {
    tabs: tabs,
    baseDs: baseDs,
    casesDs: casesDs,
    podsDs: podsDs,
    istStore: istStore,
    detailsStore: detailsStore,
    intlPrefix: intlPrefix,
    checkIstExist: checkIstExist,
    instanceId: id,
    envId: parentId.split('**')[0],
    treeDs: treeDs
  });

  return /*#__PURE__*/React.createElement(Store.Provider, {
    value: value
  }, children);
})));